Home My Page Projects Code Snippets Project Openings SML/NJ
Summary Activity Forums Tracker Lists Tasks Docs Surveys News SCM Files

SCM Repository

[smlnj] Diff of /config/trunk/install.sh
ViewVC logotype

Diff of /config/trunk/install.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

sml/branches/SMLNJ/config/install.sh revision 411, Fri Sep 3 00:25:03 1999 UTC sml/trunk/config/install.sh revision 653, Wed Jun 7 07:59:06 2000 UTC
# Line 2  Line 2 
2  #  #
3  # Copyright (c) 1994 AT&T Bell Laboratories.  # Copyright (c) 1994 AT&T Bell Laboratories.
4  #  #
5  # installation script for SML/NJ and related tools; this is a temporary  # Installation script for SML/NJ and related tools; this is a temporary
6  # placeholder until the configuration tool is finished.  # placeholder until the configuration tool is finished.
7  #  #
8    # Significant changes to accommodate (and take advantage of) the new CM
9    # by M.Blume (2/2000).
10    #
11    
12  #set -x  this=$0
13    
14  #  #
15  # get the target list  # get the target list
16  #  #
17  if [ ! -r config/targets ]; then  if [ ! -r config/targets ]; then
18    echo "!!! no target list"      echo "$this: !!! File config/targets is missing."
19    exit 1;      exit 1
20  fi  fi
21  . config/targets  . config/targets
22    
23  #  #
24  # some OSs have make in strange places  # create the preloads.standard file
25  #  #
26  MAKE=make  if [ ! -r config/preloads ]; then
27        echo "$this: !!! File config/preloads is missing."
28        exit 1
29    fi
30    cp config/preloads preloads.standard
31    
32  #  #
33  # command for building SML libraries; this should be either  # Some OSs have make in strange places, but most of the time it is
34  # "CM.recompile()" or "CM.stabilize true".  The latter builds  # simply on the PATH:
 # stable libraries, which may be somewhat faster to use.  
35  #  #
36  #CM_MAKE_LIB="CM.recompile();"  MAKE=make
 CM_MAKE_LIB="CM.stabilize true;"  
37    
 #  
 # check for ksh  
 #  
 # ksh causes some people problems so we will always use /bin/sh  
 #  
 #echo "checking for ksh"  
 #if [ -x /bin/ksh ]; then  
 #  SHELL=/bin/ksh  
 #elif [ -x /usr/local/bin/ksh ]; then  
 #  SHELL=/usr/local/bin/ksh  
 #else  
38    SHELL=/bin/sh    SHELL=/bin/sh
39  #fi  echo $this: Using shell $SHELL.
 echo "  using $SHELL"  
40    
41  #  #
42  # set the SML root directory  # set the SML root directory
43  #  #
44  REAL_PWD=`pwd`  REAL_PWD=`pwd`
45  ROOT=${PWD:-$REAL_PWD}  ROOT=${PWD:-$REAL_PWD}
46  echo "SML root is $ROOT"  echo $this: SML root is $ROOT.
47    echo $this: Installation directory is ${INSTALLDIR:=$ROOT}.
48    
49  #  #
50  # set the various directory pathname variables  # set the various directory and file pathname variables
51  #  #
52  BINDIR=$ROOT/bin  BINDIR=$INSTALLDIR/bin          # main dir for binary stuff
53  CONFIGDIR=$ROOT/config  CONFIGDIR=$ROOT/config
54  HEAPDIR=$BINDIR/.heap  HEAPDIR=$BINDIR/.heap           # where heap images live
55  RUNDIR=$BINDIR/.run  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live
56  SRCDIR=$ROOT/src  SRCDIR=$ROOT/src                # where the source tree is rooted
57  LIBDIR=$ROOT/lib  LIBDIR=$INSTALLDIR/lib          # where libraries live
58    LIBLIST=$ROOT/liblist           # list of commands to stabilize libraries
59    LIBMOVESCRIPT=$ROOT/libmove     # a temporary script
60    LOCALPATHCONFIG=$INSTALLDIR/pathconfig # a temporary pathconfig file
61    
62    URLGETTER=unknown
63    
64  #  #
65  # the paths to ml-yacc and ml-lex; needed to configure CM  # the path to the dir where ml-yacc, ml-burg, ml-lex, and ml-build live
66  #  #
67  YACCPATH=$BINDIR/ml-yacc  TOOLDIR=$BINDIR
68  LEXPATH=$BINDIR/ml-lex  
69  BURGPATH=$BINDIR/ml-burg  #
70    # A temporary file for post-editing the pathconfig file...
71    #
72    PCEDITTMP=/usr/tmp/pcedittmp.$$
73    
74    #
75    # files to be deleted after we are done...
76    #
77    tmpfiles=""
78    tmpfiles="$tmpfiles $ROOT/preloads.standard"
79    tmpfiles="$tmpfiles $LIBLIST"
80    tmpfiles="$tmpfiles $LOCALPATHCONFIG"
81    tmpfiles="$tmpfiles $LIBMOVESCRIPT"
82    tmpfiles="$tmpfiles $PCEDITTMP"
83    #
84    # make sure we always clean up after ourselves...
85    #
86    trap 'rm -f $tmpfiles' 0 1 2 3 15
87    
88    
89  #  #
90  # set the CM configuration variables (these are environment variables  # set the CM configuration variables (these are environment variables
91  # that will be queried by the bootstrap code)  # that will be queried by the bootstrap code)
92  #  -M.Blume (5/1998)  # Especially important is CM_PATHCONFIG_DEFAULT.
93  #  #
94  CM_YACC_DEFAULT=$YACCPATH  CM_PATHCONFIG_DEFAULT=$LIBDIR/pathconfig
95  CM_LEX_DEFAULT=$LEXPATH  export CM_PATHCONFIG_DEFAULT
 CM_BURG_DEFAULT=$BURGPATH  
 CM_PATH_DEFAULT=.:$LIBDIR  
 export CM_YACC_DEFAULT CM_LEX_DEFAULT CM_BURG_DEFAULT CM_PATH_DEFAULT  
96    
97  #  #
98  # the release version that we are installing  # the release version that we are installing
99  #  #
100  VERSION=`cat $CONFIGDIR/version`  VERSION=`cat $CONFIGDIR/version`
101  echo "installing version $VERSION"  echo $this: Installing version $VERSION.
102    
103  #  #
104  # create the various sub directories  # the URL for the (usually remote) source archive
105  #  #
106  for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR  SRCARCHIVEURL=`cat $CONFIGDIR/srcarchiveurl`
107  do  echo $this: URL of source archive is $SRCARCHIVEURL.
108    if [ -d $dir ]; then  
109      echo "$dir already exists"  #
110    # Function to make a directory (and advertise such action).
111    #
112    makedir() {
113        if [ ! -d $1 ] ; then
114            echo $this: Making directory $1
115            if mkdir $1 ; then
116                : everything is fine
117            else
118                echo "$this: !!! Unable to make directory $1!"
119                exit 1
120            fi
121        fi
122    }
123    
124    #
125    # Function for asking user to fetch source archive.
126    #   $1 - descriptive name
127    #   $2 - base name without extension, without version, and without dir
128    #   $3 - remote directory
129    #
130    askurl() {
131        echo "$this: Please, fetch $1 archive"
132        echo ' ('$2.'*' or $VERSION-$2.'*)'
133        echo " from $3"
134        echo " and then re-run this script!"
135        exit 1
136    }
137    
138    #
139    # Function for fetching source archives automatically using wget or lynx.
140    #   $1 - command to actually get the stuff
141    #   $2 - descriptive name
142    #   $3 - base name without extension and without dir
143    #   $4 - remote directory
144    #
145    fetchurl() {
146        getter=$1 ; shift
147        echo $this: Fetching $1 from $3. Please stand by...
148        fetched=no
149        for base in $2 $VERSION-$2 ; do
150            for ext in tar.gz tgz tar.Z tz tar tar.bz2 ; do
151                try=$base.$ext
152                echo $this: Trying $try ...
153                if $getter $3 $try $ROOT/$try ; then
154                    fetched=yes
155                    echo $this: Fetching $try was a success.
156                    break 2         # get out of both for-loops
157                else
158                    rm -f $ROOT/$try
159                fi
160            done
161        done
162        if [ $fetched = no ] ; then
163            echo $this: Fetching $try was no success.
164            echo '  ' You should try to do it manually now.
165            askurl "$1" "$2" "$3"
166        fi
167    }
168    
169    usewget() {
170        wget -nv -O $3 $1/$2
171    }
172    
173    uselynx() {
174        lynx -source $1/$2 >$3
175    }
176    
177    testurlgetter() {
178        (exec >/dev/null 2>&1 ; exec $*)
179    }
180    
181    #
182    # Function to check whether wget or lynx is available.
183    # Set URLGETTER accordingly.
184    #
185    urlgetter() {
186        if [ "$URLGETTER" = unknown ] ; then
187            if testurlgetter wget --help ; then
188                URLGETTER="fetchurl usewget"
189            elif testurlgetter lynx -help ; then
190                URLGETTER="fetchurl uselynx"
191            else
192                URLGETTER="askurl"
193            fi
194        fi
195    }
196    
197    un_tar() {
198        echo "$this: Un-TAR-ing $1 archive."
199        tar -xf $2
200    }
201    
202    un_tar_Z() {
203        echo "$this: Un-COMPRESS-ing and un-TAR-ing $1 archive."
204        zcat $2 | tar -xf -
205    }
206    
207    un_tar_gz() {
208        echo "$this: Un-GZIP-ing and un-TAR-ing $1 archive."
209        gunzip -c $2 | tar -xf -
210    }
211    
212    un_tar_bz2() {
213        echo "$this: Un-BZIP2-ing and un-TAR-ing $1 archive."
214        bunzip2 -c $2 | tar -xf -
215    }
216    
217    unarchive() {
218        # $1: descriptive string, $2: archive, $3: unpacker
219        if [ -r $ROOT/$2 ] ; then
220            $3 "$1" $ROOT/$2
221        elif [ -r $ROOT/$VERSION-$2 ]; then
222            $3 "$1" $ROOT/$VERSION-$2
223        else
224            return 1
225        fi
226    }
227    
228    #
229    # Function to unpack a source archive.
230    #
231    # $1: descriptive name of the sources to be unpacked
232    # $2: the directory into which to unpack the sources
233    # $3: the sub-directory of $2 that is going to be created by unpacking
234    # $4: the basename of the source archive (the script will check several
235    #     different suffixes to determine what kind of de-compression is to
236    #     be used)
237    #
238    # fetch_n_unpack is the helper function that does the real work.  If
239    # no archive is found locally, it invokes $URLGETTER and tries again.
240    # The variable $tryfetch is used to make sure this happens only once.
241    fetch_n_unpack() {
242        cd $2
243        if unarchive "$1" $4.tar.gz un_tar_gz ||
244           unarchive "$1" $4.tgz un_tar_gz ||
245           unarchive "$1" $4.tar.Z un_tar_Z ||
246           unarchive "$1" $4.tar un_tar ||
247           unarchive "$1" $4.tar.bz1 un_tar_bz2 ||
248           unarchive "$1" $4.tz un_tar_Z
249        then
250            : we are done
251        elif [ $tryfetch = yes ] ; then
252            urlgetter
253            $URLGETTER "$1" $4 $SRCARCHIVEURL
254            tryfetch=no
255            fetch_n_unpack "$1" "$2" "$3" "$4"
256        fi
257    }
258    
259    #
260    # The main "unpack" driver function that invokes the above helper.
261    #
262    unpack() {
263        tryfetch=yes
264        if [ -d $2/$3 ]; then
265            echo "$this: The $1 tree already exists."
266    else    else
267      echo "creating $dir"          fetch_n_unpack "$1" "$2" "$3" "$4"
268      mkdir $dir      fi
269      if [ $? != "0" ]; then      if [ ! -d $2/$3 ]; then
270        echo "unable to create $dir"          echo "$this: !!! Unable to unpack $1 archive."
271        exit 1        exit 1
272      fi      fi
273    }
274    
275    # A function to move all stable library files to a parallel directory
276    # hierarchy.
277    # The first argument must be a simple path (no / inside), and
278    # the second argument must be an absolute path.
279    move() {
280        if [ -d $1 ] ; then
281            if [ ! -d $2 ] ; then
282                if [ -f $2 ] ; then
283                    echo $this: $2 exists as a non-directory.
284                    exit 1
285                fi
286                mkdir $2
287    fi    fi
288            cd $1
289            for i in * ; do
290                move $i $2/$i
291            done
292            cd ..
293        elif [ -f $1 ] ; then
294            rm -f $2
295            mv $1 $2
296        fi
297    }
298    
299    #
300    # Move the stable archive of a library whose description file was $1/$2 to
301    # $LIBDIR/$2/CM/$ARCH-unix/$2 so that it appears as if the description file
302    # had been at $LIBDIR/$2/$2
303    #
304    # (This script will also move all other libraries that show up in
305    #  $1/CM/$ARCH-unix because in the case of the boot directory this indicates
306    #  that some library did not have its own path anchor but was specified
307    #  relative to $1/$2. Still, don't rely on this to be robust -- rather make
308    #  separate anchors for every library!)
309    #
310    movelibs() {
311        for lib in `/bin/ls $1/CM/$ARCH-unix` ; do
312            case $lib in
313            *.cm | *.cmi)
314                if [ $lib != $2 ] ; then
315                    echo "$this: Warning:" $lib specified relative to $2
316                fi
317                echo $this: Moving library $lib to $LIBDIR
318                makedir $LIBDIR/$2
319                makedir $LIBDIR/$2/CM
320                makedir $LIBDIR/$2/CM/$ARCH-unix
321                mv $1/CM/$ARCH-unix/$lib $LIBDIR/$2/CM/$ARCH-unix/$lib
322                ;;
323            *)
324                ;;
325            esac
326  done  done
327    }
328    
329    # A shell function that registers a library for being built.
330    # This function takes two arguments: 1. a name under which the library
331    # is to be known later (something.cm) and 2. the path relative to $SRCDIR
332    # that leads to the library's .cm file.  The library's .cm file must be the
333    # same as $1.
334    #
335    # This works by adding ML code to file $LIBLIST.  The code in this file
336    # will be executed near the end of this script.  If $MOVE_LIBRARIES is
337    # set to true, then reglib will also register a "movelibs" to be executed at
338    # the end by putting a "movelibs" line into $LIBMOVESCRIPT.
339    
340    reglib() {
341        if [ x$MOVE_LIBRARIES = xtrue ] ; then
342            FINALLOCATION=$LIBDIR/$1
343            FINALCONFIGPATH=$1
344        else
345            FINALLOCATION=$SRCDIR/$2
346            FINALCONFIGPATH=$FINALLOCATION
347        fi
348        if [ -d $FINALLOCATION/CM/$ARCH-unix ] ; then
349            echo "$this: Library $1 already exists in $FINALLOCATION."
350        else
351            echo "$this: Scheduling library $1 to be built in $FINALLOCATION."
352            echo "  andalso CM.stabilize false \"\$/$1\"" >>$LIBLIST
353            echo $1 $SRCDIR/$2 >>$LOCALPATHCONFIG
354            if [ x$MOVE_LIBRARIES = xtrue ] ; then
355                echo movelibs $SRCDIR/$2 $1 >>$LIBMOVESCRIPT
356            fi
357        fi
358        echo $1 $FINALCONFIGPATH >>$CM_PATHCONFIG_DEFAULT
359    }
360    
361    #
362    # Function to build a standalone program such as ml-yacc.  The function takes
363    # 2 or 3 arguments.  First the name of the program which at the same time
364    # is the directory name under $SRCDIR where the sources reside.  The second
365    # argument is a descriptive name for the program (passed on to "unpack").
366    # The optional third argument specifies the path relative to $SRCDIR/$1
367    # of the directory where the program's heap image is to be found.
368    #
369    
370    standalone() {
371        TARGET=$1.$HEAP_SUFFIX
372        if [ $# = 3 ] ; then
373            TARGETLOC=$3/$TARGET
374        else
375            TARGETLOC=$TARGET
376        fi
377        if [ -r $HEAPDIR/$TARGET ] ; then
378            echo $this: Target $TARGET already exists.
379        else
380            echo $this: Building $TARGET.
381            unpack $2 $SRCDIR $1 $1
382            cd $SRCDIR/$1
383            ./build
384            if [ -r $TARGETLOC ] ; then
385                mv $TARGETLOC $HEAPDIR/$TARGET
386                if [ ! -f $BINDIR/$1 ] ; then
387                    cd $BINDIR
388                    ln -s .run-sml $1
389                fi
390            else
391                echo "$this: !!! Build of $TARGET failed."
392            fi
393        fi
394    }
395    
396    #
397    # create the various sub directories
398    #
399    for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR ; do
400        makedir $dir
401    done
402    
403  #  #
404  # install the script that tests the architecture, and make sure that it works  # install the script that tests the architecture, and make sure that it works
405  #  #
406  if [ -x $BINDIR/.arch-n-opsys ]; then  if [ -x $BINDIR/.arch-n-opsys ]; then
407    echo "$BINDIR/.arch-n-opsys already exists"      echo $this: Script $BINDIR/.arch-n-opsys already exists.
408  else  else
409    cat $CONFIGDIR/_arch-n-opsys | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys      cat $CONFIGDIR/_arch-n-opsys \
410        | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys
411    chmod 555 $BINDIR/.arch-n-opsys    chmod 555 $BINDIR/.arch-n-opsys
412    if [ ! -x $BINDIR/.arch-n-opsys ]; then    if [ ! -x $BINDIR/.arch-n-opsys ]; then
413      echo "!!! installation of $BINDIR/.arch-n-opsys failed for some reason"          echo "$this: !!! Installation of $BINDIR/.arch-n-opsys failed."
414      exit 1      exit 1
415    fi    fi
416  fi  fi
417    
418  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`
419  if [ "$?" != "0" ]; then  if [ "$?" != "0" ]; then
420    echo "!!! $BINDIR/.arch-n-opsys fails on this machine"      echo "$this: !!! Script $BINDIR/.arch-n-opsys fails on this machine."
421    echo "!!! you must patch this by hand and repeat the installation"      echo "$this: !!! You must patch this by hand and repeat the installation."
422    exit 2    exit 2
423  else  else
424    echo "$BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS"      echo $this: Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.
425  fi  fi
426  eval $ARCH_N_OPSYS  eval $ARCH_N_OPSYS
427    
428  if [ -x $BINDIR/.run-sml ]; then  #
429    echo "$BINDIR/.run-sml already exists"  # Function to install a "driver" script...
430  else  #   This takes care of patching the source of the script with the SHELL,
431    cat $CONFIGDIR/_run-sml | \  #   BINDIR, and VERSION variables to use.
432      sed -e "s,@SHELL@,$SHELL,g" -e "s,@BINDIR@,$BINDIR," -e "s,@VERSION@,$VERSION," \  #
433      > $BINDIR/.run-sml  installdriver() {
434    chmod 555 $BINDIR/.run-sml      dsrc=$1
435    if [ ! -x $BINDIR/.run-sml ]; then      ddst=$2
436      echo "!!! installation of $BINDIR/.run-sml failed for some reason"  # We install the driver unconditionally. (It would be better to test
437    # for an outdated driver script, but not all "test" commands understand
438    # the -nt comparison operator....)
439    #   if [ -x $BINDIR/$ddst ]; then
440    #       echo $this: Script $BINDIR/$ddst already exists.
441    #   else
442            rm -f $BINDIR/$ddst
443            cat $CONFIGDIR/$dsrc | \
444            sed -e "s,@SHELL@,$SHELL,g" \
445                -e "s,@BINDIR@,$BINDIR," \
446                -e "s,@VERSION@,$VERSION," \
447                > $BINDIR/$ddst
448            chmod 555 $BINDIR/$ddst
449            if [ ! -x $BINDIR/$ddst ]; then
450                echo "$this: !!! Installation of $BINDIR/${ddst} failed."
451      exit 1      exit 1
452    fi    fi
453  fi  #   fi
454    }
455    
456    installdriver _run-sml .run-sml
457    installdriver _link-sml .link-sml
458    installdriver _ml-build ml-build
459    
460  #  #
461  # set some architecture dependent run-time system flags  # set some architecture dependent run-time system flags
462  #  #
463  case $ARCH in  case $ARCH in
464    mips*) ALLOC=1M ;;      mips*)
465            ALLOC=1M
466            ;;
467    x86)    x86)
468            # The following is the _wrong_ value for many popular x86 chips
469            # (i.e., Celerons).  However, the optimal value for those is 32k,
470            # and such a small value is not enough for the runtime system's boot
471            # code.  Therefore, we use 256k here and re-set it to the proper
472            # value in .run-sml.
473      ALLOC=256k      ALLOC=256k
474    ;;    ;;
475    alpha32)    alpha32)
# Line 155  Line 479 
479      ALLOC=512k      ALLOC=512k
480    ;;    ;;
481  esac  esac
482    
483  case $OPSYS in  case $OPSYS in
484    solaris)    solaris)
485      MAKE=/usr/ccs/bin/make      MAKE=/usr/ccs/bin/make
# Line 162  Line 487 
487    linux)    linux)
488      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`
489      if [ "$?" != "0" ]; then      if [ "$?" != "0" ]; then
490        echo "problems checking for underscores in global names"              echo "$this: !!! Problems checking for underscores in asm names."
491        exit 1        exit 1
492      fi      fi
493      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"
# Line 172  Line 497 
497  #  #
498  # the name of the bin files directory  # the name of the bin files directory
499  #  #
500  BIN_FILES=bin.$ARCH-unix  BOOT_ARCHIVE=boot.$ARCH-unix
501    BOOT_FILES=sml.$BOOT_ARCHIVE
502    
503  #  #
504  # build the run-time system  # build the run-time system
505  #  #
506  $CONFIGDIR/unpack.sh "run-time" $SRCDIR runtime $ROOT/$VERSION-runtime.tar  unpack "run-time" $SRCDIR runtime runtime
507  if [ "$?" != "0" ]; then  if [ -x $RUNDIR/run.$ARCH-$OPSYS ]; then
508    exit $?      echo $this: Run-time system already exists.
509  fi  else
 if [ ! -x $RUNDIR/run.$ARCH-$OPSYS ]; then  
510    cd $SRCDIR/runtime/objs    cd $SRCDIR/runtime/objs
511    echo "compiling the run-time system"      echo $this: Compiling the run-time system.
512    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS
513    if [ -x run.$ARCH-$OPSYS ]; then    if [ -x run.$ARCH-$OPSYS ]; then
514      mv run.$ARCH-$OPSYS $RUNDIR      mv run.$ARCH-$OPSYS $RUNDIR
515      $MAKE MAKE=$MAKE clean          # $MAKE MAKE=$MAKE clean
516    else    else
517      echo "!!! run-time system build failed for some reason"          echo "$this: !!! Run-time system build failed for some reason."
518      exit 1      exit 1
519    fi    fi
520  fi  fi
# Line 199  Line 524 
524  # boot the base SML system  # boot the base SML system
525  #  #
526  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then
527    echo "$HEAPDIR/sml.$HEAP_SUFFIX already exists"      echo $this: Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.
528  else  else
529    $CONFIGDIR/unpack.sh bin $ROOT $BIN_FILES $ROOT/$VERSION-$BIN_FILES.tar      unpack bin $ROOT $BOOT_FILES $BOOT_ARCHIVE
530        cd $ROOT/$BOOT_FILES
531        if $BINDIR/.link-sml @SMLheap=$ROOT/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC
532        then
533    cd $ROOT    cd $ROOT
   $RUNDIR/run.$ARCH-$OPSYS @SMLboot=$ROOT/$BIN_FILES @SMLalloc=$ALLOC <<XXXX  
     $SET_FLAGS  
     val use = Compiler.Interact.useFile  
     val _ = (SMLofNJ.exportML "sml";  
              print Compiler.banner;  
              print "\n");  
 XXXX  
534    if [ -r sml.$HEAP_SUFFIX ]; then    if [ -r sml.$HEAP_SUFFIX ]; then
535      mv sml.$HEAP_SUFFIX $HEAPDIR      mv sml.$HEAP_SUFFIX $HEAPDIR
536      cd $BINDIR      cd $BINDIR
537      ln -s .run-sml sml      ln -s .run-sml sml
538                #
539                # Now move all stable libraries to #LIBDIR and generate
540                # the pathconfig file.
541                #
542                cd $ROOT/$BOOT_FILES
543                for anchor in * ; do
544                    if [ -d $anchor ] ; then
545                        echo $anchor $anchor >>$CM_PATHCONFIG_DEFAULT
546                        move $anchor $LIBDIR/$anchor
547                    fi
548                done
549                cd $ROOT
550                # $BOOT_FILES is now only an empty skeleton, let's get rid of it.
551                rm -rf $BOOT_FILES
552    
553            else
554                echo "$this !!! No heap image generated (sml.$HEAP_SUFFIX)."
555                exit 1
556            fi
557    else    else
558      echo "!!! unable to build SML heap image (sml.$HEAP_SUFFIX)"          echo "$this !!! Boot code failed, no heap image (sml.$HEAP_SUFFIX)."
559      exit 1      exit 1
560    fi    fi
561  fi  fi
562    
563    #
564    # Initialize $LIBLIST
565    #
566    cd $ROOT
567    rm -f $LOCALPATHCONFIG $LIBLIST
568    echo 'ignore (OS.Process.exit (if true' >$LIBLIST
569    
570  #  #
571  # now build the individual targets  # now build (or prepare to build) the individual targets
572  #  #
573  cd $SRCDIR  cd $SRCDIR
574  echo "install targets"  echo $this: Installing other targets.
575  for i in $TARGETS  for i in $TARGETS ; do
 do  
   if [ $i = "doc" ]; then  
     TARGET=$i  
   else  
     TARGET=$i.$HEAP_SUFFIX  
   fi  
   if [ -r $HEAPDIR/$TARGET ]; then  
     echo "$TARGET already exists"  
   else  
     echo "  building $TARGET"  
576      case $i in      case $i in
577        src-smlnj)        src-smlnj)
578          for src in compiler comp-lib cm MLRISC; do          for src in compiler cm MLRISC smlnj-lib ml-yacc system
579            $CONFIGDIR/unpack.sh $src $ROOT/src $src $ROOT/$VERSION-$src.tar          do
580                unpack $src $ROOT/src $src $src
581          done          done
582        ;;        ;;
       sml-full)  
         if [ ! -d $ROOT/$BIN_FILES ]; then  
           echo "!!! bin files are missing; build of $TARGET failed"  
           exit 1  
         else  
           cd $ROOT  
           $RUNDIR/run.$ARCH-$OPSYS @SMLfull @SMLboot=$ROOT/$BIN_FILES @SMLalloc=$ALLOC <<XXXX  
             $SET_FLAGS  
             val use = Compiler.Interact.useFile  
             val _ = (SMLofNJ.exportML "sml-full";  
                      print Compiler.banner;  
                      print " [full]\n");  
 XXXX  
           if [ -r sml-full.$HEAP_SUFFIX ]; then  
             mv sml-full.$HEAP_SUFFIX $HEAPDIR  
             cd $BINDIR  
             ln -s .run-sml sml-full  
           else  
             echo "!!! unable to build SML-FULL heap image"  
             exit 1  
           fi  
         fi  
       ;;  
583        ml-yacc)        ml-yacc)
584          $CONFIGDIR/unpack.sh ML-Yacc $SRCDIR ml-yacc $ROOT/$VERSION-ml-yacc.tar          standalone ml-yacc ML-Yacc src
585          if [ "$?" != "0" ]; then          echo ml-yacc $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
           exit $?  
         fi  
         cd $SRCDIR/ml-yacc  
         ./build  
         if [ -r src/$TARGET ]; then  
           mv src/$TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
586        ;;        ;;
587        ml-lex)        ml-lex)
588          $CONFIGDIR/unpack.sh ML-Lex $SRCDIR ml-lex $ROOT/$VERSION-ml-lex.tar          standalone ml-lex ML-Lex
589          if [ "$?" != "0" ]; then          echo ml-lex $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
           exit $?  
         fi  
         cd $SRCDIR/ml-lex  
         ./build  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
590        ;;        ;;
591        ml-burg)        ml-burg)
592          $CONFIGDIR/unpack.sh ML-Burg $SRCDIR ml-burg $ROOT/$VERSION-ml-burg.tar          standalone ml-burg ML-Burg
593          if [ "$?" != "0" ]; then          echo ml-burg $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
           exit $?  
         fi  
         cd $SRCDIR/ml-burg  
         ./build  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
594        ;;        ;;
595        smlnj-lib)        smlnj-lib)
596          $CONFIGDIR/unpack.sh "SML/NJ Library" $SRCDIR smlnj-lib $ROOT/$VERSION-smlnj-lib.tar          unpack "SML/NJ Library" $SRCDIR smlnj-lib smlnj-lib
597          if [ "$?" != "0" ]; then  
598            exit $?          # Don't make the Util library -- it came pre-made and has been
599          fi          # installed when making the base system.  In other words, don't do...
600        # make the Util library              #reglib smlnj-lib.cm smlnj-lib/Util
601          cd $SRCDIR/smlnj-lib/Util          # ... and don't make the HTML library ...
602          echo "$CM_MAKE_LIB" | $BINDIR/sml              #reglib html-lib.cm smlnj-lib/HTML
603          if [ ! -f $LIBDIR/smlnj-lib.cm ]; then          # ... and don't make the PP library ...
604            cd $LIBDIR              #reglib pp-lib.cm smlnj-lib/PP
           echo "Alias $SRCDIR/smlnj-lib/Util/sources.cm" > smlnj-lib.cm  
         fi  
605        # make the Unix library        # make the Unix library
606          cd $SRCDIR/smlnj-lib/Unix              reglib unix-lib.cm smlnj-lib/Unix
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/unix-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Unix/sources.cm" > unix-lib.cm  
         fi  
607        # make the INet library        # make the INet library
608          cd $SRCDIR/smlnj-lib/INet              reglib inet-lib.cm smlnj-lib/INet
         echo "$CM_MAKE_LIB" | $BINDIR/sml-cm  
         if [ ! -f $LIBDIR/inet-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/INet/sources.cm" > inet-lib.cm  
         fi  
       # make the HTML library  
         cd $SRCDIR/smlnj-lib/HTML  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/html-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/HTML/sources.cm" > html-lib.cm  
         fi  
       # make the PP library  
         cd $SRCDIR/smlnj-lib/PP  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/pp-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/PP/sources.cm" > pp-lib.cm  
         fi  
609        # make the RegExp library        # make the RegExp library
610          cd $SRCDIR/smlnj-lib/RegExp              reglib regexp-lib.cm smlnj-lib/RegExp
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/regexp-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/RegExp/sources.cm" > regexp-lib.cm  
         fi  
611        # make the Reactive library        # make the Reactive library
612          cd $SRCDIR/smlnj-lib/Reactive              reglib reactive-lib.cm smlnj-lib/Reactive
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/reactive-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Reactive/sources.cm" > reactive-lib.cm  
         fi  
       ;;  
       ml-yacc-lib)  
         $CONFIGDIR/unpack.sh ML-Yacc $SRCDIR ml-yacc $ROOT/$VERSION-ml-yacc.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-yacc/lib  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/ml-yacc-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/ml-yacc/lib/sources.cm" > ml-yacc-lib.cm  
         fi  
613        ;;        ;;
614        cml)        cml)
615          $CONFIGDIR/unpack.sh CML $SRCDIR cml $ROOT/$VERSION-cml.tar          unpack CML $SRCDIR cml cml
616          if [ "$?" != "0" ]; then          reglib core-cml.cm cml/src/core-cml
617            exit $?          reglib cml.cm cml/src
618          fi          reglib cml-basis.cm cml
         cd $SRCDIR/cml/src  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/cml.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/cml/src/sources.cm" > cml.cm  
         fi  
619        ;;        ;;
620        cml-lib)        cml-lib)
621          $CONFIGDIR/unpack.sh CML $SRCDIR cml $ROOT/$VERSION-cml.tar          unpack CML $SRCDIR cml cml
622          if [ "$?" != "0" ]; then          reglib cml-lib.cm cml/cml-lib
           exit $?  
         fi  
         cd $SRCDIR/cml/cml-lib  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/cml-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/cml/cml-lib/sources.cm" > cml-lib.cm  
         fi  
       ;;  
       cml-cm)  
         CMD="CM.autoloading(SOME true); CM.clearAutoList();"  
         CMD="$CMD CM.autoload'(\"$LIBDIR/cml.cm\");"  
         if [ "$AUTOLOAD_CML_LIB" = "TRUE" ]; then  
           CMD="$CMD CM.autoload'(\"$LIBDIR/cml-lib.cm\");"  
         fi  
         if [ "$AUTOLOAD_EXENE" = "TRUE" ]; then  
           CMD="$CMD CM.autoload'(\"$LIBDIR/eXene.cm\");"  
         fi  
         cd $ROOT  
         $BINDIR/sml <<XXXX  
           $CMD  
           val _ = (SMLofNJ.exportML "$i";  
                 print CML.banner;  
                 print "[CML autoload]\n");  
 XXXX  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! unable to build autoloading CML"  
           exit 1  
         fi  
623        ;;        ;;
624        eXene)        eXene)
625          $CONFIGDIR/unpack.sh EXene $SRCDIR eXene $ROOT/$VERSION-eXene.tar          unpack EXene $SRCDIR eXene eXene
626          if [ "$?" != "0" ]; then          reglib eXene.cm eXene
           exit $?  
         fi  
         cd $SRCDIR/eXene  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/eXene.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/eXene/sources.cm" > eXene.cm  
         fi  
627        ;;        ;;
628        doc)        doc)
629          $CONFIGDIR/unpack.sh Doc $ROOT doc $ROOT/$VERSION-doc.tar          unpack Doc $ROOT doc doc
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
630          cd $ROOT/doc          cd $ROOT/doc
631          build $ROOT          build $ROOT
632        ;;        ;;
633        *)        *)
634          echo "!!! unknown target $i"          echo "$this: !!! Unknown target $i."
635        ;;        ;;
636      esac      esac
   fi  
637  done  done
638    
639  if [ "$ENABLE_AUTOLOADING" = "TRUE" ]; then  #
640    CMD="CM.autoloading(SOME true); CM.clearAutoList();"  # Now go and stabilize all registered libraries...
641    if [ "$AUTOLOAD_SMLNJ_LIB" = "TRUE" ]; then  # This is done with library sources in their original locations inside
642      CMD="$CMD CM.autoload'(\"$LIBDIR/smlnj-lib.cm\");"  # $SRCDIR, so we must consult $LOCALPATHCONFIG.
643    fi  #
644    if [ "$AUTOLOAD_SMLNJ_UNIX" = "TRUE" ]; then  
645      CMD="$CMD CM.autoload'(\"$LIBDIR/unix-lib.cm\");"  echo $this: Compiling library code.
646    fi  echo 'then OS.Process.success else OS.Process.failure));' >>$LIBLIST
647    if [ "$AUTOLOAD_SMLNJ_INET" = "TRUE" ]; then  if CM_LOCAL_PATHCONFIG=$LOCALPATHCONFIG $BINDIR/sml <$LIBLIST ; then
648      CMD="$CMD CM.autoload'(\"$LIBDIR/inet-lib.cm\");"      echo $this: Libraries compiled successfully.
   fi  
   if [ "$AUTOLOAD_SMLNJ_HTML" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/html-lib.cm\");"  
   fi  
   if [ "AUTOLOAD_SMLNJ_PP" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/pp-lib.cm\");"  
   fi  
   if [ "AUTOLOAD_SMLNJ_REGEXP" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/regexp-lib.cm\");"  
   fi  
   if [ "$AUTOLOAD_SMLNJ_REACTIVE" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/reactive-lib.cm\");"  
   fi  
   cd $ROOT  
   $BINDIR/sml <<XXXX  
     $CMD  
     val _ = (SMLofNJ.exportML "sml";  
              print Compiler.banner;  
              print " [CM; autoload enabled]\n");  
 XXXX  
   if [ -r sml.$HEAP_SUFFIX ]; then  
     mv sml.$HEAP_SUFFIX $HEAPDIR  
649    else    else
650      echo "!!! unable to build SML with autoloading"      echo "$this: !!! Something went wrong when compiling the libraries."
651      exit 1      exit 1
652    fi    fi
653    
654    #
655    # Move the libraries to their final locations...
656    #
657    
658    if [ -r $LIBMOVESCRIPT ] ; then
659        echo $this: Moving libraries to $LIBDIR.
660        . $LIBMOVESCRIPT
661    fi
662    
663    #
664    # Finally, remove duplicate entries from pathconfig file...
665    #
666    if [ -f $CM_PATHCONFIG_DEFAULT ] ; then
667        cp $CM_PATHCONFIG_DEFAULT $PCEDITTMP
668        rm -f $CM_PATHCONFIG_DEFAULT
669        awk <$PCEDITTMP 'NF == 2 { mapping[$1] = $2 }
670    NF != 2 { print $0 }
671    END { for (i in mapping) print i, mapping[i] }' \
672          | sort >$CM_PATHCONFIG_DEFAULT
673  fi  fi
674    
675    exit 0

Legend:
Removed from v.411  
changed lines
  Added in v.653

root@smlnj-gforge.cs.uchicago.edu
ViewVC Help
Powered by ViewVC 1.0.0